#<profile4xi profile = "02" />  
# -------------------------------------------------------------------------------------------------
#<program4xi program = "listproxy4xi.py">
#<abstract4xi abstract = "provides class ListProxy4Xi"/>
#<refer4xi reference = "managers.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'ListProxy4Xi' ] 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:
    import _winapi
except:
    pass

                
try:                 # most-common ones
    import weakref
    from traceback import format_exc         
except:
    pass
try:                 # rare ones
    import array
    import queue          
except:
    pass 
try:                 # imported-as ones 
    pass          
except:
    pass            
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                           
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing
except:
    pass
try:                             # Python ones
    from multiprocessing.managers import ListProxy
except:
    print("listproxy4xi.py *** failed in from multiprocessing.managers import ListProxy ***")
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from ace_object4xi import ace_object4xi
from baselistproxy4xi import BaseListProxy4Xi
from print4xi import print4xi
from reason_object4xi import reason_object4xi
from sense_object4xi import sense_object4xi
from time4xi import time4xi
#"
#/>


#
# =========================================================================================================================
#<class4xi class = "ListProxy4Xi" base = "BaseListProxy4Xi" child = "None" synopsis = "managers uses SyncManager" usage = "
#   managers.py
#       SyncManager.register('list', list, ListProxy)
#
#   syncmanager4xi.py:
#       SyncManager4Xi.register('list', list, ListProxy4Xi)"
#>
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# =========================================================================================================================
#
class ListProxy4Xi(BaseListProxy4Xi):
    '''
    ListProxy4Xi class: managers uses SyncManager and this class as a parameter    
    '''
    # ---------------------------------------------------------------------------------------------
    # Public API of this class
    # ---------------------------------------------------------------------------------------------    
    #<expose4xi expose = "
    _exposed_ = ('sense', 'reason', 'ace')          
    #"
    #/>  
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "iadd-of-ListProxy4X" usage = "adds value">                             
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def __iadd__(self, value):
        '''
        adds value
        '''    
        class2print = "ListProxy4Xi"
        method2print = "__iadd__"
        
        message2print = "{started" + "; iadd-of-ListProxy4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
                        
        message2print = "{passing" + "; extend-passing-to-callmethod-of-listproxy2xi-by-iadd-of-ListProxy4Xi: " + str('extend') + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
                
        message2print = "{passing" + "; value-passing-to-callmethod-of-listproxy2xi-by-iadd-of-ListProxy4Xi: " + str((value,)) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
                   
     
        
        self._callmethod('extend', (value,))

        message2print = "{performed" + "; callmethod-of-listproxy2xi-performed-by-iadd-of-ListProxy4Xi: " + str(self._callmethod) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
                       
        message2print = "{returning" + "; listproxy2xi-returning-by-iadd-of-ListProxy4Xi: " + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                                

        return self
    #</methodize4xi>
            
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "imul-of-ListProxy4Xi" usage = "multiplies value">                        
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def __imul__(self, value):
        '''
        multiplies value
        '''      
        class2print = "ListProxy4Xi"
        method2print = "__imul__"
        
        
        message2print = "{started" + "; imul-of-ListProxy4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
           
        message2print = "{passing" + "; imul-passing-to-callmethod-of-listproxy2xi-by-imul-of-ListProxy4Xi: " + str('__imul__') + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
                
        message2print = "{passing" + "; value-passing-to-callmethod-of-listproxy2xi-by-imul-of-ListProxy4Xi: " + str((value,)) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
                  
  
        self._callmethod('__imul__', (value,))
        
        message2print = "{returning" + "; listproxy2xi-returning-by-imul-of-ListProxy4Xi: " + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                                

        
        return self
    #</methodize4xi>
            

                                       
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "sense-of-ListProxy4Xi" usage = "senses ListProxy4Xi class objects">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def sense(self):
        '''
        senses ListProxy4Xi class objects
        '''
 
        
        class2print = 'ListProxy4Xi'
        method2print = 'sense'
        
        
        message2print = "{started" + "; sense-of-ListProxy4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
   
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------  
        message2print = "{sensing" + "; ListProxy4Xi-sensing-by-sense-of-ListProxy4Xi: " + str(ListProxy4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                    
        
        # -----------------------------------------------------------------------------------------
        # get sensed knowledge for this object
        # -----------------------------------------------------------------------------------------        
        kb2xi = sense_object4xi(self)
        
        message2print = "{got" + "; kb2xi-got-by-sense-of-ListProxy4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # -----------------------------------------------------------------------------------------         
        try:
            kb2xi['inheritance-of-listproxy2xi'] = BaseListProxy4Xi  
            kb2xi['callmethod-of-listproxy2xi'] = self._callmethod
        except:
            message2print = "{yielded" + "; kb2xi-yielded-by-sense-of-ListProxy4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
              
        message2print = "{sensed" + "; ListProxy4Xi-sensed-by-sense-of-ListProxy4Xi: " + str(ListProxy4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        
        # -----------------------------------------------------------------------------------------
        # 
        # -----------------------------------------------------------------------------------------         
        message2print = "{returning" + "; kb2xi-returning-by-sense-of-ListProxy4Xi: " + str(kb2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                               
          
        return kb2xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
    #</methodize4xi>
    
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "reason-of-ListProxy4Xi" usage = "reasons ListProxy4Xi class objects">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def reason(self):
        '''
        reasons ListProxy4Xi class objects
        '''
       
        
        class2print = 'ListProxy4Xi'
        method2print = 'reason'

        
        message2print = "{started" + "; reason-of-ListProxy4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
          
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        message2print = "{reasoning" + "; ListProxy4Xi-reasoning-by-reason-of-ListProxy4Xi: " + str(ListProxy4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
                
        
        # -----------------------------------------------------------------------------------------
        # get reasoned knowledge for this object
        # -----------------------------------------------------------------------------------------         
        kb4xi = reason_object4xi(self)
        
        
        message2print = "{got" + "; kb4xi-got-by-reason-of-ListProxy4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # -----------------------------------------------------------------------------------------          
        try:
            kb4xi['init-of-listproxy2xi'] = BaseListProxy4Xi.__init__  
 
        except:
            message2print = "{yielded" + "; kb4xi-yielded-by-reason-of-ListProxy4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
        
          
        
        message2print = "{reasoned" + "; ListProxy4Xi-reasoned-by-reason-of-ListProxy4Xi: " + str(ListProxy4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{returning" + "; kb4xi-returning-by-reason-of-ListProxy4Xi: " + str(kb4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                                  
          
        return kb4xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
    
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "ace-of-ListProxy4Xi" usage = "aces ListProxy4Xi class objects">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def ace(self):
        '''
        aces ListProxy4Xi class objects 
        '''
       
        
        
        class2print = 'ListProxy4Xi'
        method2print = 'ace'
        
        
        message2print = "{started" + "; ace-of-ListProxy4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
           
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        message2print = "{acing" + "; ListProxy4Xi-acing-by-ace-of-ListProxy4Xi: " + str(ListProxy4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                  
        
        # -----------------------------------------------------------------------------------------
        # get aced knowledge for this object
        # -----------------------------------------------------------------------------------------        
        kb8xi = ace_object4xi(self)  
        
        message2print = "{got" + "; kb8xi-got-by-ace-of-ListProxy4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                


        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # -----------------------------------------------------------------------------------------              
        try:
            kb8xi['add-functions-of-listproxy2xi'] = str(1)          
            kb8xi['multiply-functions-of-listproxy2xi'] = str(1)  
        except:
            message2print = "{yielded" + "; kb8xi-yielded-by-ace-of-ListProxy4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
          
        message2print = "{aced" + "; ListProxy4Xi-aced-by-ace-of-ListProxy4Xi: " + str(ListProxy4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{returning" + "; kb8xi-returning-by-ace-of-ListProxy4Xi: " + str(kb8xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                                  
        
        return kb8xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
#</class4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_none4xi.txt
#   sense-test-none4xi.xml
#   reason-test-none4xi.xml
#   ace-test-none4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of listproxy4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>



